
/* testcase && evaluation
   from Paul's proposed patch

   2021-07-11 SHL Baseline

   Build with wcc386 -wx -ox -d2
   Build with gcc -Wuninitialized -c
   Build with gcc -Wall -c

   wdis -l -s
   gcc -S
*/

// #include <stdio.h>


typedef struct _zend_mm_segment {
	struct _zend_mm_segment *next_segment;
} zend_mm_segment;

typedef struct {
  zend_mm_segment* segments_list;
} zend_mm_heap;

void zend_mm_del_segment(zend_mm_heap *heap, zend_mm_segment *segment)
{
  zend_mm_segment **p = &heap->segments_list;

  #ifndef __GNUC__
  zend_mm_segment **q;
  #endif

#ifndef __OS2__
	while (*p != segment) {
		p = &(*p)->next_segment;
	}
	*p = segment->next_segment;
#else
	while (p && *p != segment) {
		p = &(*p)->next_segment;
	}
	if (p)
		*p = segment->next_segment;
#endif


//========================================================================

// Ignore this

  #if 0
  while (p && *p != segment) {
    p = &(*p)->next_segment;
  }
  #ifdef __GNUC__
  zend_mm_segment **q;
  #endif

  *q = *p;
  *q = p && *p;
  *q = segment->next_segment;
  #endif

  #if 0
  int *i;
  *i = 0;
  #endif

  return;
}

